﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Infragistics.Win;
using Infragistics.Win.UltraWinGanttView.UIElements;
using Infragistics.Win.Misc;
using System.Drawing;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGanttView;

namespace _136608
{
    class MyCreation:IUIElementCreationFilter, IDisposable
    {
        Button spliterButton ;
        private int buttonHalfHeight = 15;
        private int prevWidth = 0;
        public void AfterCreateChildElements(UIElement parent)
        {
            if (parent is VerticalSplitterUIElement )
            {
                MangedBUttonLocation(parent.Rect, parent.Control);
            }
        }

        private void MangedBUttonLocation(Rectangle rectangle, Control control)
        {
            #region Config Spliter button
            if (spliterButton == null)
            {
                spliterButton = new Button();
                spliterButton.FlatStyle = FlatStyle.Flat;
                spliterButton.FlatAppearance.BorderSize = 0;
                spliterButton.BackColor = Color.Gray;
                spliterButton.Location = new Point(rectangle.X, rectangle.Height / 2 - buttonHalfHeight);
                spliterButton.Size = new Size(rectangle.Width, buttonHalfHeight * 2);
                spliterButton.Cursor = Cursors.Hand;
                spliterButton.Click += new EventHandler(spliterButton_Click);
                control.Controls.Add(spliterButton);
                //prevWidth = ((UltraGanttView)control).GridAreaWidth;
            }
            #endregion

            spliterButton.Location = new Point(rectangle.X, rectangle.Height / 2 - buttonHalfHeight);
        }

        void spliterButton_Click(object sender, EventArgs e)
        {

            if (((UltraGanttView)spliterButton.Parent).GridAreaWidth == ((UltraGanttView)spliterButton.Parent).VerticalSplitterMinimumResizeWidth)
                // go to expanded  satet 
                ((UltraGanttView)spliterButton.Parent).GridAreaWidth = prevWidth;
            else {  
                // go to colapsed satet 
                prevWidth = ((UltraGanttView)spliterButton.Parent).GridAreaWidth; 
                ((UltraGanttView)spliterButton.Parent).GridAreaWidth = ((UltraGanttView)spliterButton.Parent).VerticalSplitterMinimumResizeWidth;
            }
 
        }


        public bool BeforeCreateChildElements(UIElement parent)
        {
            return false;
        }


        public void Dispose()
        {
            spliterButton.Click -= new EventHandler(spliterButton_Click);
            spliterButton.Dispose();
            throw new NotImplementedException();
        }
    }
}
